<?php
// get flag
$action_flag=$_REQUEST['mode'];
// call process
mga_call_process($action_flag);

// define actions /////////////

// default list
function f_index(){
	global $wpdb,$ajax;	
	// local
	extract($_POST);
	
	
	// pager
	$pager = new Mga_Pager();
	// send part for some call / ajax
	$send_part = false;
	// mark as paid
	if(isset($_POST['markaspaid']) && $_POST['markaspaid']=='true'){
		// in
		$payouts_in=mga_map_for_in($payouts);
		// update
		if(!empty($payouts_in)){
			$wpdb->query("UPDATE ".TBL_SALES." SET `pay_dt`=NOW() WHERE `id` IN ({$payouts_in})");			
		}
		// clear flag
		$send_part=true;
	}
	
	// filter
	$filter ='';	
	if(isset($_POST['filter_mode']) && !empty($_POST['filter_mode'])){		
		// default
		$filter    = '';
		// clear
		$send_part = true;
		// blocks
		switch($filter_mode){
			case "date":							
				// amount
				$filter="AND `commission_amount`>='{$min_amount}'";
				// date	filter 	
				if(isset($sale_dt['start']) && !empty($sale_dt['start'])){
					if(isset($sale_dt['end']) && !empty($sale_dt['end'])){
						$filter.=" AND (DATE_FORMAT(`sale_dt`,'%m/%d/%Y')>='{$sale_dt['start']}' AND DATE_FORMAT(`sale_dt`,'%m/%d/%Y')<='{$sale_dt['end']}')";
					}else{
						$filter.=" AND DATE_FORMAT(`sale_dt`,'%m/%d/%Y')>='{$sale_dt['start']}'";
					}
				}
			break;
			case "all":
				$filter = '';
			break;		
		}		
	}
	// sql
	$sql="SELECT SQL_CALC_FOUND_ROWS A.id,commission_amount,sale_dt,buyer_email,item_id,transaction_id,B.email AS `affiliate_email`,
	      B.paypal_email FROM ".TBL_SALES." A JOIN ".TBL_AFFILITES." B ON(A.affiliate_id=B.id) WHERE `pay_dt` IS NULL 
		  AND pay_status='processed' {$filter} ORDER BY A.sale_dt DESC ".$pager->get_query_limit(mga_get_setting('pagination'));		
	// payout
	$payouts=$wpdb->get_results($sql);	
	// get page links
	$page_links=$pager->get_pager_links('admin.php?page=mga/admin&load=payouts');	
	// part response
	if($send_part){
		$ajax->Start_Output(false);		
		payouts_part($payouts,$page_links);
		$ajax->End_Output();
	}// no process 
	?>		
	<?php mga_box_top('Manage Payouts')?>		
		<div align="right"><a href="javascript:reload_payouts_list()"><img src="<?php echo MGA_PLUGIN_ASSETS_URL ?>images/icons/arrow_refresh.png" /></a></div>		
		<form name="frmpayoutlist" id="frmpayoutlist" method="post" action="admin.php?page=mga/admin&load=payouts"> 			
			<table cellpadding="1" cellspacing="0" border="0" class="form-table">
				<tr>
					<td>
						<b><?php _e('Start Date','mga')?>:</b> <input type="text" size="10" name="sale_dt[start]" value="<?php echo $sale_dt['start']?>"/>
						<b><?php _e('End Date','mga')?></b><input type="text" size="10" name="sale_dt[end]" value="<?php echo $sale_dt['end']?>"/>
						<b><span class="required-field"><?php _e('Minimum Payout Balance','mga');?></span></b><input type="text" name="min_amount" size="5" value="<?php echo $min_amount?>"/>
						<input type="button" value="<?php _e('Filter','mga');?>" onclick="filter_payouts()" class="button"/>
						<input type="button" value="<?php _e('Clear','mga');?>" onclick="list_all_payouts()" class="button"/>					
					</td>				
				</tr>
				<tr>
					<td align="left">
						<input type="button" value="<?php _e('Pay File','mga');?>" onclick="create_payfile()" class="button"/>
						<input type="button" value="<?php _e('Mark paid','mga');?>" onclick="mark_paid()" class="button"/>
					</td>
				</tr>
				<tr>
					<td><label id="error_all"></label></td>
				</tr>		
			</table>		
			<div id="payoutlist">
				<?php payouts_part($payouts,$page_links);?>
			</div>
		</form>															
	<?php mga_box_bottom()?>
	<script language="javascript">
		<!--
		// onready
		jQuery(document).ready(function(){   
			// set pager
			mga_set_pager('#admin_payouts');
			// reload
			reload_payouts_list=function(){
				jQuery('#admin_payouts .content-div').tabs('load',0);
			}					
			// date
			jQuery("#frmpayoutlist :input[name^='sale_dt[']").each(function(i){
						jQuery(this)
						 .attr("size","11")
						 .attr("maxlength","10")						
						 .datepicker({showOn:'focus',buttonImage:'<?php echo MGA_PLUGIN_ASSETS_URL?>/images/icons/calendar.png',buttonImageOnly:true});
			});
			// wrap scope ??? what a solution
			jQuery("#ui-datepicker-div").wrap("<div class='mga'></div>");	
			
			// filter
			filter_payouts=function(){				
				// add form validation
				jQuery("#frmpayoutlist").validate({					
					submitHandler: function(form) {					    					
						jQuery("#frmpayoutlist").ajaxSubmit({type: "POST",
												  url: 'admin.php?page=mga/admin&load=payouts',
												  dataType: 'html',		
												  data:{filter_mode:'date'},										  										 
												  beforeSubmit: function(){	
													jQuery('#wrap-admin-payouts #message').remove();		
													jQuery('#wrap-admin-payouts').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
												  },
												  success: function(data){	
														// remove 										   														
														jQuery('#wrap-admin-payouts #message').remove();
														jQuery("#payoutlist").html(data);	
														// set pager
														mga_set_pager('#admin_payouts');																																		   	
												  }});    		
						return false;											
					},
					rules: {			
						min_amount: {required:true,number:true},						
						'sale_dt[start]': {required:false,date:true},
						'sale_dt[end]': {required:false,date:true}					
					},
					messages: {			
						min_amount: {required: "<?php _e('Please enter min amount','mga')?>", number:"<?php _e('Please enter numbers','mga')?>"},
						'sale_dt[start]': {date:"<?php _e('Please enter valid date','mga')?>"},					
						'sale_dt[end]': {date:"<?php _e('Please enter valid date','mga')?>"}
					},
					errorClass: 'validation-error',
					errorPlacement: function(error, element) {						
						error.appendTo(jQuery("#error_all"));
					}
				});	
				// execute
				jQuery("#frmpayoutlist").submit();
			}
			
			// list all
			list_all_payouts=function(){
				jQuery("#frmpayoutlist").ajaxSubmit({type: "POST",
												  url: 'admin.php?page=mga/admin&load=payouts',
												  dataType: 'html',	
												  data:{filter_mode:'all'},										 
												  beforeSubmit: function(){	
												  	jQuery("#frmpayoutlist :input[type='text']").val('');
													jQuery('#wrap-admin-payouts #message').remove();		
													jQuery('#wrap-admin-payouts').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
												  },
												  success: function(data){	
														// remove 										   														
														jQuery('#wrap-admin-payouts #message').remove();
														jQuery("#payoutlist").html(data);
														// set pager
														mga_set_pager('#admin_payouts');																																	   	
												  }});   
			}
			
			// create payfile
			create_payfile=function(){
				var sel=jQuery("#frmpayoutlist :checkbox[name='payouts[]']:checked").size();	
				if(parseInt(sel)==0){
					jQuery("#error_all").html('Please select some payouts to download').addClass('validation-error');
				}else if(parseInt(sel)>0){
					jQuery("#error_all").html('').removeClass('validation-error');
					if(jQuery('#downloadcsv').attr('id')!='downloadcsv'){
						var io = document.createElement('iframe');
						io.id = io.name= "downloadcsv";   						
						io.style.position = 'absolute';
						io.style.top = '-1000px';
						io.style.left = '-1000px';            
						document.body.appendChild(io);				
					}					
					jQuery('#downloadcsv').attr('src','<?php echo admin_url('/admin.php?page=mga/admin&load=payfile_download')?>');					
				}
			}
			
			// mark as paid
			mark_paid=function(){
				// add form validation
				jQuery("#frmpayoutlist").validate({					
					submitHandler: function(form) {					    					
						jQuery("#frmpayoutlist").ajaxSubmit({type: "POST",
						  url: 'admin.php?page=mga/admin&load=payouts',
						  dataType: 'html',		
						  data:{markaspaid:'true'},											 
						  beforeSubmit: function(){	
							jQuery('#wrap-admin-payouts #message').remove();		
							jQuery('#wrap-admin-payouts').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
						  },
						  success: function(data){	
								// remove 										   														
								jQuery('#wrap-admin-payouts #message').remove();															
								// show message
								jQuery('#wrap-admin-payouts').prepend('<div id="message"></div>');	
								// show
								jQuery('#wrap-admin-payouts #message').addClass('success').html("<?php _e('Marked as paid','mga')?>");	
								// focus
								jQuery.scrollTo('#admin_payouts',400);		
								// set new data
								jQuery("#payoutlist").html(data);																																		   	
						  }});    		
						return false;											
					},
					rules: {													
						'payouts[]': {required:true,minlength:1}				
					},
					messages: {									
						'payouts[]': {required: "<?php _e('Please select a commission','mga')?>", minlength:"<?php _e('Please select one','mga')?>"}
					},
					errorClass: 'validation-error',
					errorPlacement: function(error, element) {						
						error.appendTo(jQuery("#error_all"));
					}
				});	
				// fire
				jQuery("#frmpayoutlist").submit();
			}
			// selectall
			jQuery("#frmpayoutlist :checkbox[name='selectall']").bind('click',function(){
				jQuery("#frmpayoutlist :checkbox[name='"+jQuery(this).val()+"']").attr('checked',jQuery(this).attr('checked'));
			});
		});
		//-->
	</script>			
	<?php
}

// payouts_part
function payouts_part($payouts,$page_links){
?>
	<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><?php endif; ?></div>																
	<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table widefat">
		<thead>
			<tr class="alternate">	
				<th align="center" width="5%"><input type="checkbox" name="selectall" value="payouts[]"/></th>										
				<th scope="col"><b><?php _e('Affiliate','mga')?></b></th>
				<th scope="col"><b><?php _e('Commission Amount','mga')?></b></th>
				<th scope="col"><b><?php _e('Sale Date/Time','mga')?></b></th>
				<th scope="col"><b><?php _e('Buyer Email','mga')?></b></th>
				<th scope="col"><b><?php _e('Item ID','mga')?></b></th>
				<th scope="col"><b><?php _e('Transaction ID','mga')?></b></th>
			</tr>
		</thead>
		<tbody>
			<?php payout_list($payouts)?>
		</tbody>	
	</table>	
	<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><div class="clearfix"></div><?php endif; ?></div>	
<?php
}

// history
function f_history(){
	global $wpdb,$ajax;	
	// local
	extract($_POST);
	// pager
	$pager = new Mga_Pager();
	// send part for some call / ajax
	$send_part = false;
	
	$filter ='';	
	if(isset($_POST['filter_mode']) && !empty($_POST['filter_mode'])){		
		// default
		$filter    = '';
		// clear
		$send_part = true;
		// blocks
		switch($filter_mode){
			case "date":							
				// amount
				$filter="AND `commission_amount`>='{$min_amount}'";
				// date	filter 	
				if(isset($sale_dt['start']) && !empty($sale_dt['start'])){
					if(isset($sale_dt['end']) && !empty($sale_dt['end'])){
						$filter.=" AND (DATE_FORMAT(`sale_dt`,'%m/%d/%Y')>='{$sale_dt['start']}' AND DATE_FORMAT(`sale_dt`,'%m/%d/%Y')<='{$sale_dt['end']}')";
					}else{
						$filter.=" AND DATE_FORMAT(`sale_dt`,'%m/%d/%Y')>='{$sale_dt['start']}'";
					}
				}
			break;
			case "all":
				$filter = '';
			break;		
		}		
	}
	
	// sql
	$sql="SELECT SQL_CALC_FOUND_ROWS A.id,commission_amount,sale_dt,buyer_email,item_id,transaction_id,
	      B.email AS `affiliate_email`,pay_dt FROM ".TBL_SALES." A JOIN ".TBL_AFFILITES." B ON(A.affiliate_id=B.id) 
		  WHERE `pay_dt` IS NOT NULL AND pay_status='processed' {$filter} ORDER BY A.pay_dt DESC ".$pager->get_query_limit(mga_get_setting('pagination'));	
	// payouts	  
	$payouts=$wpdb->get_results($sql);
	// get page links
	$page_links=$pager->get_pager_links('admin.php?page=mga/admin&load=payouts&mode=history');
	// part response
	if($send_part){
		$ajax->Start_Output(false);				
		payouts_history_part($payouts,$page_links);
		$ajax->End_Output();
	}// no process
	?>		
	<?php mga_box_top('Payouts History')?>
		<div align="right"><a href="javascript:reload_payouts_history_list()"><img src="<?php echo MGA_PLUGIN_ASSETS_URL ?>images/icons/arrow_refresh.png" /></a></div>			
		<form name="frmpayhistlist" id="frmpayhistlist" method="post" action="admin.php?page=mga/admin&load=payouts&mode=history"> 				
			<table cellpadding="1" cellspacing="0" border="0" class="form-table">
				<tr>
					<td>
						<b><?php _e('Start Date','mga')?>:</b> <input type="text" name="sale_dt[start]" value="<?php echo $sale_dt['start']?>"/>
						<b><?php _e('End Date','mga')?></b><input type="text" name="sale_dt[end]" value="<?php echo $sale_dt['end']?>"/>
						<b><span class="required-field"><?php _e('Minimum Payout Balance','mga');?></span></b><input type="text" name="min_amount" size="5" value="<?php echo $min_amount?>"/>
						<input type="button" value="<?php _e('Filter','mga');?>" onclick="filter_payouts_history()" class="button"/>		
						<input type="button" value="<?php _e('Clear','mga');?>" onclick="list_all_payouts_history()" class="button"/>			
						<label id="error_all"></label>
					</td>
				</tr>
			</table>
			<div id="payouthistlist">			
				<?php payouts_history_part($payouts,$page_links);?>
			</div>
		</form>			
	<?php mga_box_bottom()?>
	<script language="javascript">
		<!--
		// onready
		jQuery(document).ready(function(){   
			// set pager
			mga_set_pager('#admin_payouts',1);
			// reload
			reload_payouts_history_list=function(){
				jQuery('#admin_payouts .content-div').tabs('load',1);
			}								
			// date
			jQuery("#frmpayhistlist :input[name^='sale_dt[']").each(function(i){
						jQuery(this)
						 .attr("size","11")
						 .attr("maxlength","10")						
						 .datepicker({showOn:'focus',buttonImage:'<?php echo MGA_PLUGIN_ASSETS_URL?>/images/icons/calendar.png',buttonImageOnly:true});
			});
			// wrap scope ??? what a solution
			jQuery("#ui-datepicker-div").wrap("<div class='mga'></div>");	
			
			// filter history
			filter_payouts_history=function(){				
				// add form validation
				jQuery("#frmpayhistlist").validate({					
					submitHandler: function(form) {					    					
						jQuery("#frmpayhistlist").ajaxSubmit({type: "POST",
												  url: 'admin.php?page=mga/admin&load=payouts&mode=history',
												  dataType: 'html',		
											      data:{filter_mode:'date'},										 
												  beforeSubmit: function(){	
													jQuery('#wrap-admin-payouts #message').remove();		
													jQuery('#wrap-admin-payouts').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
												  },
												  success: function(data){	
														// remove 										   														
														jQuery('#wrap-admin-payouts #message').remove();
														jQuery("#payouthistlist").html(data);	
														// set pager
														mga_set_pager('#admin_payouts',1);																																		   	
												  }});    		
						return false;											
					},
					rules: {			
						min_amount: {required:true,number:true},						
						'sale_dt[start]': {required:false,date:true},
						'sale_dt[end]': {required:false,date:true}					
					},
					messages: {			
						min_amount: {required: "<?php _e('Please enter min amount','mga')?>", number:"<?php _e('Please enter numbers','mga')?>"},
						'sale_dt[start]': {date:"<?php _e('Please enter valid date','mga')?>"},					
						'sale_dt[end]': {date:"<?php _e('Please enter valid date','mga')?>"}
					},
					errorClass: 'validation-error',
					errorPlacement: function(error, element) {						
						error.appendTo(jQuery("#error_all"));
					}
				});	
				// fire
				jQuery("#frmpayhistlist").submit();
			}		
			// list all history
			list_all_payouts_history=function(){
				jQuery("#frmpayhistlist").ajaxSubmit({type: "POST",
												  url: 'admin.php?page=mga/admin&load=payouts&mode=history',
												  dataType: 'html',	
												  data:{filter_mode:'all'},										 
												  beforeSubmit: function(){	
												  	jQuery("#frmpayhistlist :input[type='text']").val('');
													jQuery('#wrap-admin-payouts #message').remove();		
													jQuery('#wrap-admin-payouts').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
												  },
												  success: function(data){	
														// remove 										   														
														jQuery('#wrap-admin-payouts #message').remove();
														jQuery("#payouthistlist").html(data);	
														// set pager
														mga_set_pager('#admin_payouts',1);																																			   	
												  }});   
			}		
		});
		//-->
	</script>
	<?php
}

// payouts_history_part
function payouts_history_part($payouts,$page_links){
	?>
	<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><?php endif; ?></div>																
	<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table widefat">
		<thead>
			<tr class="alternate">															
				<th scope="col"><b><?php _e('Affiliate','mga')?></b></th>
				<th scope="col"><b><?php _e('Commission Amount','mga')?></b></th>
				<th scope="col"><b><?php _e('Sale Date/Time','mga')?></b></th>
				<th scope="col"><b><?php _e('Buyer Email','mga')?></b></th>
				<th scope="col"><b><?php _e('Item ID','mga')?></b></th>
				<th scope="col"><b><?php _e('Transaction ID','mga')?></b></th>
				<th scope="col"><b><?php _e('Pay Date/Time','mga');?></b></th>
			</tr>
		</thead>
		<tbody>
			<?php payout_list($payouts,true)?>
		</tbody>	
	</table>		
	<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><div class="clearfix"></div><?php endif; ?></div>
	<?php
}
// payout list
function payout_list($payouts,$history=false){		
	// no redord
	if(count($payouts)==0):?>
	<tr class="alternate" id="row-0">		
		<td colspan="7" align="center"><?php _e('No Payouts'.(($history)?' History':''),'mga')?></td>
	</tr>
	<?php
	endif;
	// show
	foreach ($payouts as $payout) :?>
	<tr class="alternate" id="row-<?php echo $payout->id?>">	
		<?php if(!$history):?>	
		<td align="center" width="5%">
			<?php if(empty($payout->paypal_email) || is_null($payout->paypal_email)):?>
			<img src="<?php echo MGA_PLUGIN_ASSETS_URL?>/images/icons/email_error.png" title="No Paypal Email"/>
			<?php else:?>			
			<input type="checkbox" name="payouts[]" value="<?php echo $payout->id?>"/>
			<?php endif;?>
		</td>	
		<?php endif?>									
		<td valign="top"><?php echo $payout->affiliate_email?></td>				
		<td valign="top"><?php echo mga_get_setting('currency_symbol').$payout->commission_amount?></td>	
		<td valign="top"><?php echo date(mga_get_setting('long_date_format'),strtotime($payout->sale_dt))?></td>
		<td valign="top"><?php echo !empty($payout->buyer_email) ? $payout->buyer_email : 'N/A'?></td>
		<td valign="top"><?php echo !empty($payout->item_id) ? $payout->item_id : 'N/A'?></td>	
		<td valign="top"><?php echo !empty($payout->transaction_id) ? $payout->transaction_id : 'N/A'?></td>	
		<?php if($history):?>		
		<td valign="top"><?php echo date(mga_get_setting('long_date_format'),strtotime($payout->pay_dt))?></td>
		<?php endif?>				
	</tr>
	<?php	 	
	endforeach;		
}
// end of file