<?php
// get flag
$action_flag=$_REQUEST['mode'];
// call process
mga_call_process($action_flag);
// define actions /////////////
// default list
function f_index(){
	global $wpdb;
	
	$affiliate_id          = intval($_SESSION['SESS_AFF_USER_ID']);	
	$number_of_sales       = $wpdb->get_var("SELECT COUNT(id) FROM ".TBL_SALES." WHERE 1 AND pay_dt IS NULL AND item_type='sales' AND pay_status='processed' AND affiliate_id='{$affiliate_id}'");
	$standard_earnings     = $wpdb->get_var("SELECT SUM(commission_amount) FROM `".TBL_SALES."` WHERE 1 AND pay_dt IS NULL AND item_type='sales' AND pay_status='processed' AND affiliate_id='{$affiliate_id}'");	
	$tier_earning          = $wpdb->get_var("SELECT SUM(commission_amount) FROM `".TBL_SALES."` WHERE 1 AND pay_dt IS NULL AND item_type='sales' AND pay_status='processed' AND affiliate_id='{$affiliate_id}'
										     AND `affiliate_id`<>(SELECT `affiliate_id` FROM `".TBL_CLICKS."` WHERE id=`click_id`)");
	$recurring_earnings    = $wpdb->get_var("SELECT SUM(commission_amount) FROM `".TBL_SALES."` WHERE 1 AND pay_dt IS NULL AND item_type='sales' AND pay_status='processed' AND `buyer_id` IS NOT NULL AND affiliate_id='{$affiliate_id}'");	
	$total_visitors        = $wpdb->get_var("SELECT COUNT(id) FROM ".TBL_CLICKS." WHERE 1 AND affiliate_id='{$affiliate_id}'");
	$total_unique_visitors = $wpdb->get_var("SELECT COUNT(DISTINCT(ip)) FROM ".TBL_CLICKS." WHERE 1 AND affiliate_id='{$affiliate_id}'");
	$total_sales           = $wpdb->get_var("SELECT COUNT(id) FROM `".TBL_SALES."` WHERE 1 AND pay_dt IS NULL AND item_type='sales' AND pay_status='processed' AND affiliate_id='{$affiliate_id}'");
	?>
	<div class="content-div">
		<table width="100%" cellpadding="1" cellspacing="1" border="0" class="form-table widefat">
			<thead>
				<tr class="alternate">															
					<th scope="col" colspan="2"><b><?php _e('Current Commission - From Last Payout to Date [Only Processed Sales Reported]','mga');?></b></th>																												
				</tr>
			</thead>
			<tbody>				
				<tr class="alternate">
					<td width="20%"><?php _e('Transactions','mga');?></td><td width="80%"><?php echo $number_of_sales?></td>
				</tr>
				<tr class="alternate">
					<td><?php _e('Standard Earnings','mga');?></td><td><?php echo mga_get_setting('currency_symbol').number_format($standard_earnings,2,'.','.')?></td>
				</tr>
				<tr class="alternate">
					<td><?php _e('Tier Earnings','mga');?></td><td><?php echo mga_get_setting('currency_symbol').number_format($tier_earning,2,'.','.')?></td>
				</tr>
				<tr>
					<td><?php _e('Recurring Earnings','mga');?></td><td><?php echo mga_get_setting('currency_symbol').number_format($recurring_earnings,2,'.','.')?></td>
				</tr>
				<tr class="alternate">
					<td><?php _e('Current Earnings','mga');?></td><td><?php echo mga_get_setting('currency_symbol').number_format(($standard_earnings+$tier_earning),2,'.','.')?></td>
				</tr>
			</tbody>	
		</table>
		<br />
		<table width="100%" cellpadding="1" cellspacing="1" border="0" class="form-table widefat">
			<thead>
				<tr class="alternate">															
					<th scope="col" colspan="3"><b><?php _e('Traffic Statistics','mga');?></b></th>																												
				</tr>
			</thead>
			<tbody>				
				<tr class="alternate">
					<td width="20%"><?php _e('Visitors','mga');?></td><td width="20%"><?php echo $total_visitors?></td>
				    <td rowspan="4" width="60%" valign="top" align="center">
						<div style="margin-top:25px"><?php _e('This Statistics do not include recurring or tier commissions.','mga');?></div>
					</td>
				</tr>
				<tr class="alternate">
					<td><?php _e('Unique Visitors','mga');?></td><td><?php echo $total_unique_visitors?></td>
			    </tr>
				<tr class="alternate">
					<td><?php _e('Total Sales','mga');?></td><td><?php echo $total_sales?></td>
			    </tr>
				<tr>
					<?php 
					if($total_visitors>0){	
						$sales_ratio=($total_sales/$total_visitors)*100;
					}else{
						$sales_ratio=0;
					}?>
					<td><?php _e('Sales Ratio','mga');?></td><td><?php echo number_format($sales_ratio,'2','.',',')?>%</td>
			    </tr>				
			</tbody>	
		</table>
		<br />
		<table width="100%" cellpadding="1" cellspacing="1" border="0" class="form-table widefat">
			<thead>
				<tr class="alternate">															
					<th scope="col"><b><?php _e('Payout Type','mga');?></b></th>
					<th scope="col"><b><?php _e('Current Payout Level','mga');?></b></th>																												
				</tr>
			</thead>
			<tbody>				
				<tr class="alternate">
					<td width="20%"><?php _e('Pay-Per-Sale','mga');?></td>
					<td width="80%">
						<?php 
						if(mga_get_setting('tier_commission')=='Y'){
							_e('Tier 1 : ','mga') ; 
							$tier_commissions = mga_get_setting('tier_commissions');			
							echo $tier_commissions[1].'%';					
						}else{							
							// user row
							$configrow = $wpdb->get_var("SELECT config FROM `".TBL_AFFILITES."` WHERE id='{$affiliate_id}'");		
							// config
							$config = json_decode($configrow,true);
							// individual override enabled
							if(!is_null($config) && $config['commission_level_enabled']=='Y'){
								_e('Individual : ','mga'); 
								// take individual
								$commission_level =$config['commission_level'];
								$commission_type  =$config['commission_type'];
							}else{		
								_e('General : ','mga'); 
								// take default
								$commission_level =mga_get_setting('commission_level','general',30);	
								$commission_type  =mga_get_setting('commission_type','general','flat');
							}
							echo $commission_level . ' ' . ($commission_type=='percent'?'%':mga_get_setting('currency_code'));
						}?>
					</td>
				</tr>				
			</tbody>	
		</table>
		<br />
		<table width="100%" cellpadding="1" cellspacing="1" border="0" class="form-table widefat">
			<thead>
				<tr class="alternate">															
					<th scope="col" colspan="2"><b><?php _e('Notes from The Administrator','mga');?></b></th>																												
				</tr>
			</thead>
			<tbody>				
				<tr class="alternate">
					<td width="100%" colspan="2">
						<?php echo mga_stripslashes_deep(mga_get_setting('admin_notes','affcenter','No notes'));?>
					</td>
				</tr>				
			</tbody>	
		</table>
	</div>
	<?php
}
// end of file