<?php
// dump
function mga_array_dump($array){
	echo '<pre>';
	print_r($array);
	echo '</pre>';
}
// log
function mga_log($data){

    static $incrementer=1;

    // id

    define('LOG_REQUEST_ID' , substr(microtime(),2,8));

    // log

    $fp         = fopen(WP_PLUGIN_DIR.'/magicaffiliate/protected/logs/'.LOG_REQUEST_ID.'.log', "a+");

    $begin_crlf = "";

    $end_crlf   = "\n\r";

    // write

    fwrite($fp, $begin_crlf . ($incrementer++) .':'. $end_crlf . $data);

    // close

    fclose($fp);

}
// box top
function mga_box_top($title, $helpkey="", $return=false, $attributes=false){
	// defaults
	$attributes_default=array('width'=>845,'style'=>'margin:10px 0;');
	// attributes
	if(is_array($attributes)){
		$options=array_merge($attributes_default,$attributes);
	}else{
		$options=$attributes_default;
	}
	// local
	extract($options);	
	
	// help key
	if(empty($helpkey)){
		$helpkey=strtolower(preg_replace('/\s+/','',$title));
	}
	// html
	$html= '<div class="ma-panel-box" style="'.$style.($width ? 'width: ' . ($width) . 'px;':'') .'">			
				<div class="box-title" style="' .($width ? 'width: ' . ($width-5) . 'px;':'') . '">			
					<h3>'.__($title, 'mga').'</h3>				
						<div class="box-triggers">
							<img src="'.MGA_PLUGIN_ASSETS_URL.'images/panel/help-image.png" alt="description" class="box-description" />							
							<img src="'.MGA_PLUGIN_ASSETS_URL.'images/panel/television.png" alt="video" class="box-video" />
						</div>						
						<div class="box-description-content">				
							<p>'.mga_get_tip($helpkey).'</p>				
						</div> <!-- end box-description-content div -->						
						<div class="box-video-content">				
							<p>'.mga_get_video($helpkey).'</p>				
						</div> <!-- end box-video-content div -->				
					</div> <!-- end div box-title -->				
					<div class="box-content">';	
			  
	// return output
	if ($return) {
		return $html;
	} else {
		echo $html;
	}
}

// box bottom
function mga_box_bottom($return=false){
	$html = '</div>
		   </div>';
	if ($return) {
		return $html;
	} else {
		echo $html;
	}
}

// tips
function mga_get_tip($key){
	global 	$mga_tips_info;
	return (isset($mga_tips_info[$key]))?$mga_tips_info[$key]:"[tip '$key' missing]";
}	

// videos
function mga_get_video($key){	
	global 	$mga_videos_info;
	return (isset($mga_videos_info[$key]))?$mga_videos_info[$key]:"[video '$key' missing]";
}

// executor
function mga_call_process($func,$default='f_index'){
	// set name flag
	$func="f_{$func}";
	// when set
	if(isset($func) && is_callable($func)){		
		call_user_func($func);
	// default	
	}else if(isset($default) && is_callable($default)){
		call_user_func($default);
	// else
	}else{
		echo 'error loading method';
	}
}

// countries_array 
function mga_countries_array(){
	global $wpdb;
	$countries = $wpdb->get_results("SELECT code,name FROM ".TBL_COUNTRIES." WHERE 1 ORDER BY name ASC");
	$countries_array = array();
	if($countries){		
		foreach($countries as $country){
			$countries_array[$country->code]=$country->name;
		}
	} 
	// send
	return $countries_array;
}

// affiliates_array
function mga_affiliates_array(){
	global $wpdb;
	$affiliates = $wpdb->get_results("SELECT id,email FROM ".TBL_AFFILITES." WHERE 1 ORDER BY firstname ASC");
	$affiliates_array = array();
	if($affiliates){		
		foreach($affiliates as $affiliate){
			$affiliates_array[$affiliate->id]=$affiliate->email;
		}
	} 
	// send
	return $affiliates_array;
}

// url
function mga_affaccount_url($path){
	// path
	if(!defined('MGA_AFFLIATE_ACCOUNT_URL')){
		$account_url    =array();
		$account_url[]  =trailingslashit(site_url());
		$account_url[]  =(get_option('permalink_structure')=='')?'?':'';
		$account_url[]  =MGA_AFFCENTER_URLNAME;	
		$account_url[]  =((get_option('permalink_structure')=='')?'=':'/');
		// account path
		define('MGA_AFFLIATE_ACCOUNT_URL',implode('',$account_url));	
	}	
	// dounble check for ?
	$account_url = MGA_AFFLIATE_ACCOUNT_URL . $path;
	// when not ?
	$account_url = ( !preg_match('/\?/', $account_url) )? preg_replace('/&/','?',$account_url,1) : $account_url;
	// return
	return $account_url;
}

// infobar
function mga_render_infobar() {
	$style = 'style="color:#161616; text-decoration:none;"';	

	echo '<div id="mga-info" style="float:right; color:#161616; padding-top:10px; padding-right:15px;">
			<strong>
				Magic Affiliate |
				Support |
				V. ' . MGA_PLUGIN_VERSION . ' - '. MGA_PLUGIN_PRODUCT_NAME .'			
			</strong>
		</div>';
}

// config
function mga_get_setting($key,$group='general',$default=''){
	$mga_settings =get_option('mga_settings');
	$settings     =$mga_settings[$group];	
	
	return (isset($settings[$key]))?$settings[$key]:$default;
}

// mail
function mga_mail($to, $subject, $message, $from="", $subject_charset = 'UTF-8', $message_charset = 'UTF-8'){		
	// form
	// list($from_name,$from_email)=explode(',',$from);	
	if(!empty($from)){
		list($from_name,$from_email) = explode(',',$from);	
	}else{
		$from_name  = get_option('blogname');
		$from_email = get_option('admin_email');
	}
		
	/*
	$from_name  = urlencode($from_name);
	$from_email = urlencode($from_email);	
	$bcc_email  = "Bcc:".mga_get_setting('contact_email');
	$bcc        = (mga_get_setting('notify_admin')=='Y')?$bcc_email:"";
	*/	
	$bcc_email = '';//'Bcc: yespbs@gmail.com';
	
	// header
	$headers = "MIME-Version: 1.0
	From: {$from_name} <{$from_email}>
	Reply-To: {$from_email}
	{$bcc_email}
	Return-Path: {$from_email}
	X-Sender: {$from_email}
	X-Mailer: PHP/" . phpversion() . "
	Content-Type: text/html; charset=\"$message_charset\"
	Content-Transfer-Encoding: 8bit";
    // sent
	wp_mail($to, $subject, $message, $headers);
}

// output
function mga_output_banner($banner,$format,$sample=false){
	// query string append	
	$qsa        =( preg_match('/\?/', $banner->target_url) || (get_option('permalink_structure')=='') ) ? '&' : '?' ;
	$target_url =$banner->target_url . $qsa . 'affid='.$_SESSION['SESS_AFF_USER_ID'];
	switch($format){
		case 'html':
			switch($banner->banner_type){
				case "image":
					// image prop	
					if(is_null($banner->image_property)){
						$image_property         = new StdClass();
						$image_property->width  ='100';
						$image_property->height ='100';
					}else{
						$image_property=json_decode($banner->image_property);
					}
					// property
					if($sample){
						//$img_prop="class='size-thumbnail wp-noborder'";
						$img_prop="height='{$image_property->height}' width='{$image_property->width}'";
					}else{
						$img_prop="height='{$image_property->height}' width='{$image_property->width}'";
					}
					$html_format="<a href='%s' target='_blank'><img src='%s' alt='%s' %s border='0'></a>";
					$html=vsprintf($html_format,array($target_url,$banner->image_url,$banner->link_text,$img_prop));
				break;
				case "link":
					$html_format="<a href='%s' alt='%s' target='_blank'>%s</a>";
					$html=vsprintf($html_format,array($target_url,$banner->link_text,$banner->link_text));
				break;
				case "flash":
					$html_format="%s";
					$html=vsprintf($html_format,array($banner->flash_embed));
				break;
			}			
		break;
		case 'js':
		break;	
	}
	
	return $html;
}

// get auth


// set auth


// validate 


// remote call
function mga_remote_request($url, $error_string=true) {
    $string = '';
        
	if (ini_get('allow_url_fopen')) {
		if (!$string = @file_get_contents($url)) {
            if ($error_string) {
				$string = 'Could not connect to the server to make the request.';
            }
		}
	} else if (extension_loaded('curl')) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$string = curl_exec($ch);
		curl_close($ch);
	} else if ($error_string) {
	    $string = 'This feature will not function until either CURL or fopen to urls is turned on.';
	}

	return $string;
}

// get commision per sale
function mga_get_affiliate_commission_amount($affiliate_id,$sale_amount){
	global $wpdb;
	// if tier commission is in effect, take it and disregard all
	if(mga_get_setting('tier_commission')=='Y'){
		$tier_commissions = mga_get_setting('tier_commissions');	
		return ($tier_commissions[1]/100)*$sale_amount;	// why 1 ?
	}
	
	// user row
	$configrow=$wpdb->get_var("SELECT config FROM `".TBL_AFFILITES."` WHERE id='{$affiliate_id}'");		
	// config
	$config=json_decode($configrow,true);
	// individual override enabled
	if(!is_null($config) && $config['commission_level_enabled']=='Y'){
		// take individual
		$commission_level =$config['commission_level'];
		$commission_type  =$config['commission_type'];
	}else{		
		// take default
		$commission_level =mga_get_setting('commission_level','general',30);	
		$commission_type  =mga_get_setting('commission_type','general','flat');
	}
	
	// default
	switch($commission_type){
		case "flat":
			return $commission_level;
		break;
		case "percent":
			return ($commission_level/100)*$sale_amount;
		break;		
	}
	
	// just in case, send flat 30$
	return 30;
}

// get commision per sale
function mga_get_affiliate_recurring_commission_amount($affiliate_id,$sale_amount){
	global $wpdb;		
	// user row
	$configrow=$wpdb->get_var("SELECT config FROM `".TBL_AFFILITES."` WHERE id='{$affiliate_id}'");		
	// config
	$config=json_decode($configrow,true);
	// individual override enabled
	if(!is_null($config) && $config['recurring_commission_enabled']=='Y'){
		// take individual
		$commission_level =$config['recurring_commission_level'];
		$commission_type  =$config['recurring_commission_type'];
	}else{		
		// take default
		$commission_level =mga_get_setting('recurring_commission_level','general',10);	
		$commission_type  =mga_get_setting('recurring_commission_type','general','flat');
	}
	
	// on type
	switch($commission_type){
		case "flat":
			return $commission_level;
		break;
		case "percent":
			return ($commission_level/100)*$sale_amount;
		break;		
	}
	
	// just in case, error send flat 10$
	return 10;
}

// get total earning
function mga_affiliate_commission_total($affiliate_id){
	global $wpdb;	
	$sql="SELECT SUM( `commission_amount` ) AS total_commission FROM `".TBL_SALES."` GROUP BY `affiliate_id` HAVING affiliate_id ='{$affiliate_id}'";	
	$commission_amount = $wpdb->get_var($sql);	
    return ($commission_amount)?$commission_amount:'0.00';	
}

// mail to affiliate
function mga_mail_notify_affiliate($id,$type='sale'){
	global $wpdb;
	
	// on type
	switch($type){		
		case 'sale':
			// sql
			$sql="SELECT A.*,B.email AS `affiliate_email`,CONCAT(B.title,' ',B.firstname,' ',B.lastname) AS `affiliate_name` 
				  FROM ".TBL_SALES." A JOIN ".TBL_AFFILITES." B ON(A.affiliate_id=B.id) WHERE A.id='{$id}'";
			// sale 
			$sale = $wpdb->get_row($sql);
			// set mail
			$subject  =mga_get_setting('sale_notification_subject','emailtemplates');	
			$from     =get_option('blogname').','.get_option('admin_email');
			$message  =mga_get_setting('sale_notification_body','emailtemplates');
			// set message vars	
			$message  =str_replace('[name]'       , $sale->affiliate_name, $message);
			$message  =str_replace('[buyer_name]' , $sale->buyer_name    , $message);
			$message  =str_replace('[amount]'     , $sale->totalprice    , $message);
			$message  =str_replace('[sale_date]'  , date(mga_get_setting('long_date_format'),strtotime($sale->sale_dt)), $message);
			$message  =str_replace('[commission]' , $sale->commission_amount, $message);	
			// to mail					   
			$affiliate_email = $sale->affiliate_email;
		break;
		case 'signup':
			// sql
			$sql="SELECT *,CONCAT(title,' ',firstname,' ',lastname) AS `affiliate_name` FROM ".TBL_AFFILITES." WHERE `id`='{$id}'";			
			// affiliate
			$affiliate = $wpdb->get_row($sql);			
			// set mail
			$subject  =mga_get_setting('signup_notification_subject','emailtemplates');	
			$from     =get_option('blogname').','.get_option('admin_email');
			$message  =mga_get_setting('signup_notification_body','emailtemplates');
			// set message vars	
			$message  =str_replace('[name]'            , $affiliate->affiliate_name  , $message);
			$message  =str_replace('[site]'            , get_option('blogname')      , $message);						
			$message  =str_replace('[email]'           , $affiliate->email           , $message);
			$message  =str_replace('[company]'         , $affiliate->company         , $message);
			$message  =str_replace('[website]'         , $affiliate->website         , $message);
			$message  =str_replace('[phone]'           , $affiliate->phone           , $message);
			$message  =str_replace('[join_date]'       , date(mga_get_setting('long_date_format'), strtotime($affiliate->create_dt)), $message);		
			// to mail					   
			$affiliate_email = $affiliate->email;			
		break;		
	}
	// send mail	
	mga_mail($affiliate_email, $subject, $message, $from);	
}

// mail to admin
function mga_mail_notify_admin($id,$type='sale'){
	global $wpdb;
	
	// notify_admin	enabled
	if(mga_get_setting('notify_admin')!='Y')
		return ;

	// on type
	switch($type){		
		case 'sale':
			// sql
			$sql="SELECT A.*,B.email AS `affiliate_email`,CONCAT(B.title,' ',B.firstname,' ',B.lastname) AS `affiliate_name` 
			      FROM ".TBL_SALES." A JOIN ".TBL_AFFILITES." B ON(A.affiliate_id=B.id) WHERE A.id='{$id}'";
			// sale	
			$sale = $wpdb->get_row($sql);
			// set mail
			$subject  =mga_get_setting('sale_notification_admin_subject','emailtemplates');	
			$from     =get_option('blogname').','.get_option('admin_email');
			$message  =mga_get_setting('sale_notification_admin_body','emailtemplates');
			// set message vars	
			$message  =str_replace('[name]'           , 'Admin'                , $message);
			$message  =str_replace('[site]'           , get_option('blogname') , $message);			
			$message  =str_replace('[affiliate_name]' , $sale->affiliate_name  , $message);
			$message  =str_replace('[buyer_name]'     , $sale->buyer_name      , $message);
			$message  =str_replace('[amount]'         , $sale->totalprice      , $message);
			$message  =str_replace('[sale_date]'      , date(mga_get_setting('long_date_format'),strtotime($sale->sale_dt)), $message);
			$message  =str_replace('[commission]'     , $sale->commission_amount , $message);		
		break;
		case 'signup':
			// sql
			$sql="SELECT *,CONCAT(title,' ',firstname,' ',lastname) AS `affiliate_name` FROM ".TBL_AFFILITES." WHERE `id`='{$id}'";			
			// affiliate
			$affiliate = $wpdb->get_row($sql);			
			// set mail
			$subject  =mga_get_setting('signup_notification_admin_subject','emailtemplates');	
			$from     =get_option('blogname').','.get_option('admin_email');
			$message  =mga_get_setting('signup_notification_admin_body','emailtemplates');
			// set message vars	
			$message  =str_replace('[name]'            , 'Admin', $message);
			$message  =str_replace('[site]'            , get_option('blogname')      , $message);			
			$message  =str_replace('[affiliate_name]'  , $affiliate->affiliate_name  , $message);
			$message  =str_replace('[email]'           , $affiliate->email           , $message);
			$message  =str_replace('[company]'         , $affiliate->company         , $message);
			$message  =str_replace('[website]'         , $affiliate->website         , $message);
			$message  =str_replace('[phone]'           , $affiliate->phone           , $message);
			$message  =str_replace('[join_date]'       , date(mga_get_setting('long_date_format'),strtotime($affiliate->create_dt)), $message);			
		break;						   
	}						   
	// send mail					   
	mga_mail(mga_get_setting('contact_email','general',get_option('admin_email')), $subject, $message, $from);
}

// payment status
function mga_check_payment_status($sale){
	global $wpdb;
	// nothing for signup
	if($sale->item_type=='signup')
		return $sale->pay_status;
	
    // check status
	$processed = $wpdb->get_var("SELECT processed FROM `".$wpdb->prefix."wpsc_purchase_logs` WHERE id='{$sale->purchaseid}'");	
	
	// int
	$processed = intval($processed);
	
	// 2=>Accepted Payment, 3=>Job Dispatched
	if($processed==2 || $processed==3){
		// already processed
		if($sale->pay_status=='processed'){
			return $sale->pay_status;
		}		
		// update when not processed
		$wpdb->update(TBL_SALES, array('pay_status' => 'processed'), array( 'id' => $sale->id ));
		// mail to affiliate
		mga_mail_notify_affiliate($sale->id);
		// mail to admin
		mga_mail_notify_admin($sale->id,'sale');
		// send
		return 'processed';		
	// 4=>Closed Order	
	}else if($processed==4){
		// update
		$wpdb->update(TBL_SALES, array('pay_status' => 'refund'), array( 'id' => $sale->id ));
		// send
		return 'refund';
	}
		
	// return default
	return $sale->pay_status;	
}


// get subscription status

// set all tier commissions
function mga_create_tier_commissions($sale_id){
	global $wpdb;
	// tiers
	$tier_commissions = mga_get_setting('tier_commissions');	
	$tier_levels      = mga_get_setting('tier_levels');
	// affiliate
	$affiliate = $wpdb->get_row("SELECT * FROM ".TBL_SALES." WHERE `id`='{$sale_id}'");
	// parent 
	$parent_affiliate_id = $wpdb->get_var("SELECT DISTINCT(`parent_affiliate_id`) FROM ".TBL_AFFILITE_TIERS." WHERE `affiliate_id`='{$affiliate->affiliate_id}'");	
	// loop
	$level=1;
	$sub_affiliates=array();
	while(intval($parent_affiliate_id)>0){
		// next level
		$level++;
		// gather all subs
		$sub_affiliates[$level]=$parent_affiliate_id;
		// parent 
		$parent_affiliate_id = $wpdb->get_var("SELECT `parent_affiliate_id` FROM ".TBL_AFFILITE_TIERS." WHERE `affiliate_id`='{$parent_affiliate_id}'");
		// break
		if($level==($tier_levels)) break; 
	}	
	
	// set price
	if(count($sub_affiliates)>0){
		$tier=2;
		foreach($sub_affiliates as $level=>$parent_affiliate_id){
			$commission_amount=($tier_commissions[$tier]/100)*$affiliate->totalprice;
			$columns =array('affiliate_id' => $parent_affiliate_id, 'click_id' => $affiliate->click_id, 'purchaseid' => $affiliate->purchaseid , 
			                'totalprice' => $affiliate->totalprice, 'commission_amount' => $commission_amount, 'sale_dt' => $affiliate->sale_dt, 
							'buyer_name' => $affiliate->buyer_name, 'buyer_email' => $affiliate->buyer_email, 'item_type' => 'sales' , 
							'item_id' => $affiliate->item_id, 'transaction_id' => $affiliate->transaction_id, 'pay_status' => $affiliate->pay_status);
			// insert
			$success=$wpdb->insert(TBL_SALES, $columns);
			$sale_id=$wpdb->insert_id;
			$tier++;	
			// mail when processed
			if($affiliate->pay_status=='processed'){
				// mail to affiliate
				mga_mail_notify_affiliate($sale_id);
				// mail to admin
				mga_mail_notify_admin($sale_id,'sale');
			}
		}
	}
}

// auto responders
function mga_send_autoresponder($affiliate_id){
	global $wpdb;
	
	// active_module ?	
	$ar_active_module = mga_get_setting('active_module','autoresponders');	
	if("" != $ar_active_module){							
		// affiliate data
		$affiliate = $wpdb->get_row("SELECT * FROM ".TBL_AFFILITES." WHERE id='{$affiliate_id}'");
		// ar config, at a time only one can be fired								
		$ar_config = mga_get_setting($ar_active_module, 'autoresponders');		
		// aweber availble only, may add others later TODO
		switch($ar_active_module){
			case 'aweber':
				// check id and send
				if(isset($ar_config['form_id']) && isset($ar_config['unit'])){
					mga_aweber_send_post($ar_config,$affiliate);
				}
			break;
			case 'getresponse':
				// check id and send
				if(isset($ar_config['category1']) && isset($ar_config['ref'])){
					mga_getresponse_send_post($ar_config,$affiliate);
				}
			break;
			case 'mailchimp':
				// check id and send
				if(isset($ar_config['unique_id']) && isset($ar_config['apikey'])){
					mga_mailchimp_send_post($ar_config,$affiliate);
				}
			break;
		}		
	}	
}

// aweber post
function mga_aweber_send_post($ar_config,$affiliate){
	// ar config
	$form_id      = $ar_config['form_id'];
	$unit         = $ar_config['unit'];				
	// user
	$user_email   = stripslashes($affiliate->email);		
	$display_name = stripslashes($affiliate->title.' '.$affiliate->firstname.' '.$affiliate->lastname);		
			
	$pfields = array(
				"meta_web_form_id" => $form_id,
				"meta_split_id" => "",
				"unit" => $unit,
				"redirect" => "http://www.aweber.com/form/thankyou_vo.html",
				"meta_redirect_onlist" => "",
				"meta_adtracking" => "",
				"meta_message" => "1",
				"meta_required" => "from",
				"meta_forward_vars" => "0",
				"from" => $user_email,
				"name" => $display_name,
				"submit" => "Submit");		
	
	$ch = curl_init('http://www.aweber.com/scripts/addlead.pl');					
	$headers = array("User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11", "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5", "Accept-Language: en-us,en;q=0.5", "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7", "Keep-Alive: 300", "Connection: keep-alive",);
	curl_setopt($ch, CURLOPT_TIMEOUT, 5);		
	curl_setopt($ch, CURLOPT_POST, true);
	$postfields = array();
	if ( count($pfields) )
		foreach ( $pfields as $i => $f )
			$postfields[] = urlencode($i) . '=' . urlencode($f);
	
	$fields = implode('&', $postfields);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
	$headers[] = "Content-Type: application/x-www-form-urlencoded";
	$headers[] = "Content-Length: " . strlen($fields);
	curl_setopt($ch, CURLOPT_HEADER, $headers);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_REFERER, mga_affaccount_url(''));
	$res = curl_exec($ch);		
	curl_close($ch);	
}

// getresponse post
function mga_getresponse_send_post($ar_config,$affiliate){
	// ar config
	$category1   = $ar_config['category1'];
	$ref         = $ar_config['ref'];				
	// user
	$user_email   = stripslashes($affiliate->email);		
	$display_name = stripslashes($affiliate->title.' '.$affiliate->firstname.' '.$affiliate->lastname);		
			
	$pfields = array(
				"campaign_name" => $category1,				
				"custom_ref" => $ref,
				"subscriber_email" => $user_email,
				"subscriber_name" => $display_name,
				"submit" => "Subscribe");		
	
	$ch = curl_init('http://www.getresponse.com/cgi-bin/add.cgi');					
	$headers = array("User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11", "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5", "Accept-Language: en-us,en;q=0.5", "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7", "Keep-Alive: 300", "Connection: keep-alive",);
	curl_setopt($ch, CURLOPT_TIMEOUT, 5);		
	curl_setopt($ch, CURLOPT_POST, true);
	$postfields = array();
	if ( count($pfields) )
		foreach ( $pfields as $i => $f )
			$postfields[] = urlencode($i) . '=' . urlencode($f);
	
	$fields = implode('&', $postfields);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
	$headers[] = "Content-Type: application/x-www-form-urlencoded";
	$headers[] = "Content-Length: " . strlen($fields);
	curl_setopt($ch, CURLOPT_HEADER, $headers);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_REFERER, mga_affaccount_url(''));
	$res = curl_exec($ch);		
	curl_close($ch);	
}

// mailchimp post
function mga_mailchimp_send_post($ar_config,$affiliate){
	// ar config
	$unique_id      = $ar_config['unique_id'];
	$apikey         = $ar_config['apikey'];				
	// user
	$user_email   = stripslashes($affiliate->email);		
	$display_name = stripslashes($affiliate->title.' '.$affiliate->firstname.' '.$affiliate->lastname);		
			
	$pfields = array(
				"id" => $unique_id,				
				"apikey" => $apikey,				
				"email_address" => $user_email,
				"merge_vars[FNAME]" => $display_name,
				"submit" => "Submit");		
	
	// mailchipmp url must be configured
	list($key, $dc) = explode("-",$mailchimp_apikey,2);
    if (!$dc) $dc = "us1";
		
	$url = $dc.'.'.'api.mailchimp.com/1.2/?output=php&method=listSubscribe'; 
	$ch  = curl_init($url);		
				
	$headers = array("User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11", "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5", "Accept-Language: en-us,en;q=0.5", "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7", "Keep-Alive: 300", "Connection: keep-alive",);
	curl_setopt($ch, CURLOPT_TIMEOUT, 5);		
	curl_setopt($ch, CURLOPT_POST, true);
	$postfields = array();
	if ( count($pfields) )
		foreach ( $pfields as $i => $f )
			$postfields[] = urlencode($i) . '=' . urlencode($f);
	
	$fields = implode('&', $postfields);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
	$headers[] = "Content-Type: application/x-www-form-urlencoded";
	$headers[] = "Content-Length: " . strlen($fields);
	curl_setopt($ch, CURLOPT_HEADER, $headers);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_REFERER, mga_affaccount_url(''));
	$res = curl_exec($ch);		
	curl_close($ch);	
}
// pad string
function mga_pad_string($str,$len=50,$linebrk=""){
	// trim space
	$str=trim(strip_tags($str));
	// nothing
	if($str=="")
		return "&nbsp;";
	
	// when length matched
	if(strlen($str)>$len){
		if($linebrk==""){
			# no line break </br>
			$str=substr($str,0,$len-5);
			$str=str_pad($str,$len,".",STR_PAD_RIGHT);
		}else{
			# break after length
			$str=chunk_split($str,$len,$linebrk);	   
		}
	}
	// return 
	return $str;
} 

// ui version
function mga_get_jqueryui_version(){
	// compare version if greater than 2.9
	if (version_compare(get_bloginfo('version'), '2.9', '>=')){
		// ui 1.7.3 for jQuery 1.4+ options : 1.7.3 , 1.8.2
		$jqueryui_version = get_option('mga_jqueryui_version');
		if(!$jqueryui_version){// not defined, use as coded
			$jqueryui_version = '1.7.3';		
			update_option('mga_jqueryui_version', $jqueryui_version); // and update		 
		}
	}else{
		// ui 1.7.2 for jQuery 1.3.2+
		$jqueryui_version = '1.7.2';			 
	}
	// return
	return $jqueryui_version;
}

// deep stripslashes
function mga_stripslashes_deep($data){	
	// clean till found '\'
	do{
		$data = stripslashes($data);
	}while(strpos($data, '\\') !==false);	
	// return
	return $data;
}

// recursive slash remove
function mga_array_stripslashes($v) {		
	// return stripped
	return is_array($v) ? array_map('mga_array_stripslashes', $v) : stripslashes($v);	
}

// recursive slash add
function mga_array_addslashes($v) {
	// is it enabled, return as 
	if(MGA_MAGIC_QUOTES_GPC){
		return $v;
	}
	// return stripped
	return is_array($v) ? array_map('mga_array_addslashes', $v) : addslashes($v);
}
// end of file