<?php
// options
// update
$mga_update_setting = false;
// new option should be merged
$old_settings=get_option('mga_settings');
// email templates
$emailtemplates = $old_settings['emailtemplates'];
// check
if(!isset($emailtemplates['sale_notification_admin_body']) || empty($emailtemplates['sale_notification_admin_body'])){
	// update flag
	$mga_update_setting = true;
	
	// emailtemplates admin sale notify
	$mga_settings['emailtemplates']['sale_notification_admin_subject']  = 'New Sale Notification';
	$mga_settings['emailtemplates']['sale_notification_admin_body']     = 'Dear [name],'.
																		  'A sale commission generated on [site]:'.
																		  'Affiliate: [affiliate_name]'.
																		  'Buyer: [buyer_name]'.
																		  'Sale Amount: [amount]'.
																		  'Sale Date: [sale_date]'.
																		  'Commission: [commission]'.
																		  'Regards,'.
																		  'Magic Affiliate Team';
	
	// emailtemplates admin signup notify
	$mga_settings['emailtemplates']['signup_notification_admin_subject']  = 'Signup Notification';
	$mga_settings['emailtemplates']['signup_notification_admin_body']     = 'Dear [name],'. 
																			'A new Signup on [site]:'. 
																			'Affiliate: [affiliate_name]'. 	
																			'Email: [email]'. 
																			'Company: [company]'. 
																			'Website: [website]'. 
																			'Phone: [phone]'. 
																			'Join Date: [join_date]'.
																			'Regards,'.
																			'Magic Affiliate Team';
}	

// check
if(!isset($emailtemplates['signup_notification_body']) || empty($emailtemplates['signup_notification_body'])){
	// update
	$mga_update_setting = true;
	
	// emailtemplates admin signup notify
	$mga_settings['emailtemplates']['signup_notification_subject']  = 'Welcome to [site]';
	$mga_settings['emailtemplates']['signup_notification_body']     = 'Dear [name],'.
																	  'Congratulations, you are now a registered Affiliate of [site]'.
																	  'Regards,'.
																	  'Magic Affiliate Team';
}

// when we have a go
if($mga_update_setting){
	// merge
	if(is_array($old_settings)){
		$new_settings=array_merge($old_settings,$mga_settings);
	}else{
		$new_settings=$mga_settings;
	}
	// update
	update_option('mga_settings', $new_settings);
}	
// end file