<?php

// get flag

$action_flag=$_REQUEST['mode'];

// call process

mga_call_process($action_flag);



// define actions /////////////



// default list

function f_index(){

	global $wpdb;

	// pager

	$pager = new Mga_Pager();

	// sql

	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM ".TBL_BANNERS." ORDER BY create_dt DESC ".$pager->get_query_limit(mga_get_setting('pagination'));	

	// rows	

	$banners=$wpdb->get_results($sql);

	// get page links

	$page_links=$pager->get_pager_links('admin.php?page=mga/admin&load=banners');	

	?>

	<?php mga_box_top('Manage/List of Banners')?>

	<div align="right"><a href="javascript:reload_banners_list()"><img src="<?php echo MGA_PLUGIN_ASSETS_URL ?>images/icons/arrow_refresh.png" /></a></div>		

	<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><?php endif; ?></div>		

		<form name="frmbanlist" id="frmbanlist" method="post" action="admin.php?page=mga/admin&load=banners"> 															

			<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table widefat">

				<thead>

					<tr class="alternate">											

						<th scope="col"><b><?php _e('ID','mga')?>#</b></th>

						<th scope="col"><b><?php _e('Name','mga')?></b></th>												

						<th scope="col"><b><?php _e('Description','mga')?></b></th>			

						<th scope="col"><b><?php _e('Link Text/ALT','mga')?></b></th>

						<th scope="col"><b><?php _e('Target URL','mga')?></b></th>

						<th scope="col"><b><?php _e('Image URL','mga')?></b></th>

						<th scope="col"></th>

					</tr>

				</thead>

				<tbody>

					<?php if(count($banners)==0):?>

					<tr class="alternate" id="row-0">		

						<td colspan="7" align="center"><?php _e('No Banners','mga')?></td>

					</tr>

					<?php endif;	

															

					// show

					foreach ($banners as $banner) :?>

					<tr class="alternate" id="row-<?php echo $banner->id?>">											

						<td valign="top"><?php echo $banner->id?></td>

						<td valign="top"><?php echo $banner->name?></td>

						<td valign="top"><?php echo $banner->description?></td>	

						<td valign="top"><?php echo $banner->link_text?></td>			

						<td valign="top"><?php echo $banner->target_url?></td>

						<td valign="top"><?php echo $banner->image_url?></td>				

						<td valign="top" nowrap="nowrap">

							<a href="javascript:banner_edit('<?php echo $banner->id?>')"><img src="<?php echo MGA_PLUGIN_ASSETS_URL?>images/icons/edit.png" /></a>

							<a href="javascript:banner_delete('<?php echo $banner->id?>')"><img src="<?php echo MGA_PLUGIN_ASSETS_URL?>images/icons/cross.png" /></a>

						</td>

					</tr>

					<?php endforeach;

					// page links

					?>			

				</tbody>	

			</table>

		</form>	

		<div align="right"><?php if($page_links):?><div class="pager-wrap"><?php echo $page_links?></div><div class="clearfix"></div><?php endif; ?></div>	

	<?php mga_box_bottom()?>

	<script language="javascript">

		<!--

		// set pager

		mga_set_pager('#admin_banners');

		// reload

		reload_banners_list=function(){

			jQuery('#admin_banners .content-div').tabs('load',0);

		}

		// edit

		banner_edit=function(id){			

			jQuery('#admin_banners .content-div').tabs('remove',1);

			jQuery('#admin_banners .content-div').tabs('add','admin.php?page=mga/admin&load=banners&mode=edit&id='+id,'Edit Banner',1);

			jQuery('#admin_banners .content-div').tabs('select',1);

		}

		// delete

		banner_delete=function(id){

			// confirm

			if(!confirm('You are about to delete one row, are you sure!')){

				return ;

			}

			// send

			jQuery.ajax({url:'admin.php?page=mga/admin&load=banners',

						type:'POST',

						dataType:'json',

						data:{mode:'delete',id:id},

						beforeSubmit: function(){	

							jQuery('#wrap-admin-banners #message').remove();		

							jQuery('#wrap-admin-banners').prepend('<div id="message" class="running"> Sending request...</div>');									  	

					    },

						success: function(data){											   														

									jQuery('#wrap-admin-banners #message').remove();	

									jQuery('#wrap-admin-banners').prepend('<div id="message"></div>');	

									jQuery('#wrap-admin-banners #message').addClass(data.status).html(data.message);	

									jQuery.scrollTo('#admin_banners',400);

									if(data.status=='success'){

										jQuery("#frmbanlist #row-"+id).remove();

									}								   	

			  			}});    			  

		}

		//-->

	</script>

	<?php								

}



// add

function f_add(){	

	global $wpdb;

	// save

	if(isset($_POST['process']) && $_POST['process']=='true'){		

		extract($_POST);

		if(!empty($name)){

			// check name unique

			if(mga_is_duplicate(TBL_BANNERS,array('name'))){

				$status  ='error';

				$message =__('Banner name is duplicate, please provide a unique name.','mga');

			}else{

				$columns =array('name' => $name, 'description' => $description, 'link_text' => $link_text, 'target_url' => $target_url, 

				                'image_url' => $image_url, 'image_property' => json_encode($image_property), 'flash_embed' => $flash_embed, 

								'banner_type' => $banner_type, 'create_dt' => date('Y-m-d h:i:s') );			

				$success=$wpdb->insert(TBL_BANNERS, $columns);

				if($success){

					$status  ='success';

					$message =__('Banner created successfully.','mga');

				}else{

					$status  ='error';

					$message =__('Database error occurred','mga');

				}

			}	

		}else{

			$status  ='error';

			$message =__('Banner name not provided.','mga');

		}		

		// the response

		echo json_encode(array('status'=>$status,'message'=>$message));

		exit();

	}

	// image property

	$image_property=new StdClass();

	$image_property->width='100';

	$image_property->height='100';

	// show form

	?>

	<?php mga_box_top('Add Banner')?>	

	<form name="frmbanadd" id="frmbanadd" method="post" action="admin.php?page=mga/admin&load=banners&mode=add">

		<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table">		

			<tbody>				

				<tr>

					<td width="25%" valign="top"><span class="required-field"><?php _e('Name','mga')?></span></td>

					<td valign="top"><input type="text" name="name" size="40"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Target URL','mga')?></span></td>

					<td valign="top"><input type="text" name="target_url" size="100"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Type','mga')?></span></td>

					<td valign="top"><?php print mga_make_radio_group('banner_type',mga_enum_field_values(TBL_BANNERS,'banner_type'),'image')?></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Link/Alt Text','mga')?></span></td>

					<td valign="top"><input type="text" name="link_text" size="50"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Image URL','mga')?></span></td>

					<td valign="top">

						<input type="text" name="image_url" size="100"/><br />

						<?php _e('Width','mga')?>:<input type="text" size="5" name="image_property[width]" value="<?php echo $image_property->width?>"/> 

						<?php _e('Height','mga')?>:<input type="text" size="5" name="image_property[height]" value="<?php echo $image_property->height?>"/>

					</td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Flash Embed','mga')?></span></td>

					<td valign="top"><textarea name="flash_embed" cols="50" rows="5"></textarea></td>

				</tr>

				<tr>

					<td valign="top"><span class="not-required"><?php _e('Description','mga')?></span></td>

					<td valign="top">

						<textarea name="description" cols="50" rows="5"></textarea>

					</td>

				</tr>				

				<tr>

					<td valign="top"></td>

					<td valign="top">

						<input type="submit" name="btn_save" value="<?php _e('Save','mga')?>" class="button"/>

						<a href="javascript:banner_cancel()" class="button"><?php _e('Cancel','mga')?></a>

					</td>

				</tr>

			</tbody>	

		</table>	

		<input type="hidden" name="process" value="true" />

	</form>											

	<br />	

	<?php mga_box_bottom()?>

	<script language="javascript">

		<!--

		// onready

		jQuery(document).ready(function(){   

			// cacel

			banner_cancel=function(){

				jQuery('#admin_banners .content-div').tabs('select',0);

			}			

			// first field focus 	

			jQuery("#frmbanadd :input:first").focus();							

			// add login form validation

			jQuery("#frmbanadd").validate({					

				submitHandler: function(form) {					    					

					jQuery("#frmbanadd").ajaxSubmit({type: "POST",

									          url: 'admin.php?page=mga/admin&load=banners&mode=add',

			                                  dataType: 'json',											 

											  beforeSubmit: function(){	

											  	jQuery('#wrap-admin-banners #message').remove();		

												jQuery('#wrap-admin-banners').prepend('<div id="message" class="running"> <?php _e('Saving','mga');?>...</div>');									  	

											  },

											  success: function(data){	

											  		// remove 										   														

													jQuery('#wrap-admin-banners #message').remove();	

													// cancel to list

													if(data.status=='success'){														

														jQuery("#frmbanadd :input")

														.not(":input[type='hidden']")

														.not(":input[type='submit']")

														.val('');

														banner_cancel(data);	

													}

													// show message

													jQuery('#wrap-admin-banners').prepend('<div id="message"></div>');	

													// show

													jQuery('#wrap-admin-banners #message').addClass(data.status).html(data.message);	

													// focus

													jQuery.scrollTo('#admin_banners',400);								   	

											  }});    		

					return false;											

				},

				rules: {			

					name: "required",						

					target_url: "required",

					banner_type: "required",

					link_text:{required:function(){ return jQuery("#frmbanadd :radio[name='banner_type']:checked").val()=='link';}},			

					image_url:{required:function(){ return jQuery("#frmbanadd :radio[name='banner_type']:checked").val()=='image';}},		

					flash_embed:{required:function(){ return jQuery("#frmbanadd :radio[name='banner_type']:checked").val()=='flash';}}	

				},

				messages: {			

					name: "Please enter name",

					target_url: "Please enter target url",

					banner_type: "Please select banner type",

					link_text: "Please enter link text",

					image_url: "Please enter image url",

					flash_embed: "Please enter flash embed"

				},

				errorClass: 'validation-error'

			});				

		});	

		//-->		

	</script>

	<?php

}



// edit 

function f_edit(){

	global $wpdb;

	// load data

	$id=intval($_GET['id']);

	

	// save

	if(isset($_POST['process']) && $_POST['process']=='true'){		

		extract($_POST);

		if(!empty($name)){

			if(mga_is_duplicate(TBL_BANNERS,array('name'),"AND `id`<>'{$id}'")){

				$status  ='error';

				$message =__('Banner name is already registered, please provide a unique name.','mga');

			}else{

				$columns =array('name' => $name, 'description' => $description, 'link_text' => $link_text, 'target_url' => $target_url, 

				                'image_url' => $image_url, 'image_property' => json_encode($image_property), 'flash_embed' => $flash_embed, 

								'banner_type' => $banner_type, 'is_active' => $is_active );			

				$success=$wpdb->update(TBL_BANNERS, $columns, array( 'id' => $id ));

				if($success){

					$status  ='success';

					$message =__('Banner updated successfully.','mga');

				}else{

					$status  ='error';

					$message =__('Database error occurred','mga');

				}

			}	

		}else{

			$status  ='error';

			$message =__('Banner name not provided.','mga');

		}		

		// the response

		echo json_encode(array('status'=>$status,'message'=>$message));

		exit();

	}

	

	// row

	$banner=$wpdb->get_row("SELECT * FROM ".TBL_BANNERS." WHERE id='{$id}'");	

	

	// image prop	

	if(is_null($banner->image_property)){

		$image_property=new StdClass();

		$image_property->width='100';

		$image_property->height='100';

	}else{

		$image_property=json_decode($banner->image_property);

	}

	// show form

	?>

	<?php mga_box_top('Edit Banner')?>	

	<form name="frmbanedit" id="frmbanedit" method="post" action="admin.php?page=mga/admin&load=banners&mode=edit&id=<?php echo $id?>">

		<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table">		

			<tbody>				

				<tr>

					<td width="25%" valign="top"><span class="required-field"><?php _e('Name','mga')?></span></td>

					<td valign="top"><input type="text" name="name" value="<?php echo $banner->name?>" size="40"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Target URL','mga')?></span></td>

					<td valign="top"><input type="text" name="target_url" value="<?php echo $banner->target_url?>" size="100"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Type','mga')?></span></td>

					<td valign="top"><?php print mga_make_radio_group('banner_type',mga_enum_field_values(TBL_BANNERS,'banner_type'),$banner->banner_type)?></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Link/Alt Text','mga')?></span></td>

					<td valign="top"><input type="text" name="link_text" value="<?php echo $banner->link_text?>" size="50"/></td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Image URL','mga')?></span></td>

					<td valign="top">

						<input type="text" name="image_url" value="<?php echo $banner->image_url?>" size="100"/>

						<?php _e('Width','mga')?>:<input type="text" size="5" name="image_property[width]" value="<?php echo $image_property->width?>"/> 

						<?php _e('Height','mga')?>:<input type="text" size="5" name="image_property[height]" value="<?php echo $image_property->height?>"/>

					</td>

				</tr>

				<tr>

					<td valign="top"><span class="required-field"><?php _e('Flash Embed','mga')?></span></td>

					<td valign="top"><textarea name="flash_embed" cols="50" rows="5"><?php echo $banner->flash_embed?></textarea></td>

				</tr>

				<tr>

					<td valign="top"><span class="not-required"><?php _e('Description','mga')?></span></td>

					<td valign="top">

						<textarea name="description" cols="50" rows="5"><?php echo $banner->description?></textarea>

					</td>

				</tr>

				<tr>

					<td valign="top"><span class="not-required"><?php _e('Is Active','mga')?></span></td>

					<td valign="top"><?php print mga_make_radio_group('is_active',mga_enum_field_values(TBL_BANNERS,'is_active'),$banner->is_active)?></td>

				</tr>				

				<tr>

					<td valign="top"></td>

					<td valign="top">

						<input type="submit" name="btn_save" value="<?php _e('Save','mga')?>" class="button"/>

						<a href="javascript:banner_cancel()" class="button"><?php _e('Cancel','mga')?></a>

					</td>

				</tr>

			</tbody>	

		</table>	

		<input type="hidden" name="process" value="true" />

	</form>											

	<br />	

	<?php mga_box_bottom()?>

	<script language="javascript">

		<!--

		// onready

		jQuery(document).ready(function(){   

			// cacel

			banner_cancel=function(data){

				// remove edit

				jQuery('#admin_banners .content-div').tabs('remove',1);

				// add tab

				jQuery('#admin_banners .content-div').tabs('add','admin.php?page=mga/admin&load=banners&mode=add','Add Banner',1);								

				// show

				jQuery('#admin_banners .content-div').tabs('select',0);	

			}			

			// first field focus 	

			jQuery("#frmbanedit :input:first").focus();							

			// add login form validation

			jQuery("#frmbanedit").validate({					

				submitHandler: function(form) {					    					

					jQuery("#frmbanedit").ajaxSubmit({type: "POST",

									          url: 'admin.php?page=mga/admin&load=banners&mode=edit&id=<?php echo $id?>',

			                                  dataType: 'json',											 

											  beforeSubmit: function(){	

											  	jQuery('#wrap-admin-banners #message').remove();		

												jQuery('#wrap-admin-banners').prepend('<div id="message" class="running"> <?php _e('Saving','mga');?>...</div>');									  	

											  },

											  success: function(data){											   														

											  		// clear old message

													jQuery('#wrap-admin-banners #message').remove();	

													// cancel to list		

													if(data.status=='success'){

														banner_cancel(data);												

													}

													// create message

													jQuery('#wrap-admin-banners').prepend('<div id="message"></div>');	

													// show

													jQuery('#wrap-admin-banners #message').addClass(data.status).html(data.message);

													// focus

													jQuery.scrollTo('#admin_banners',400);																			   	

											  }});    		

					return false;											

				},

				rules: {			

					name: "required",						

					target_url: "required",

					banner_type: "required",

					link_text:{required:function(){ return jQuery("#frmbanedit :radio[name='banner_type']:checked").val()=='link';}},			

					image_url:{required:function(){ return jQuery("#frmbanedit :radio[name='banner_type']:checked").val()=='image';}},		

					flash_embed:{required:function(){ return jQuery("#frmbanedit :radio[name='banner_type']:checked").val()=='flash';}}	

				},

				messages: {			

					name: "Please enter name",

					target_url: "Please enter target url",

					banner_type: "Please select banner type",

					link_text: "Please enter link text",

					image_url: "Please enter image url",

					flash_embed: "Please enter flash embed"

				},

				errorClass: 'validation-error'

			});				

		});	

		//-->		

	</script>	

	<?php

}



// delete 

function f_delete(){

	// default

	$status  ='error';

	$message =__('Banner id not provided.','mga');

	// delete

	if(isset($_POST['id']) && intval($_POST['id'])>0){

		global $wpdb;

		extract($_POST);

		$success=$wpdb->query("DELETE FROM ".TBL_BANNERS." WHERE id='{$id}'");		

		if($success){

			$status  ='success';

			$message =__('Banner deleted successfully.','mga');

		}else{

			$status  ='error';

			$message =__('Database error occurred','mga');

		}		

	}	

	// the response

	echo json_encode(array('status'=>$status,'message'=>$message));

	exit();

}

// end of file