<?php
// get flag
$action_flag=$_REQUEST['mode'];
// call process
mga_call_process($action_flag);
// define actions /////////////
// default list
function f_index(){
mga_show_dashboard();	
}

// show_dashboard
function mga_show_dashboard(){
	global $wpdb;
	?>
	<div>
		<h2><?php _e('Stats Overview','mga')?></h2>
		<form name="frmstatsoverview" id="frmstatsoverview" method="post" action="admin.php?page=mga/admin&load=dashboard">
		<table width="100%" cellpadding="1" cellspacing="0" border="0" class="form-table">
			<tr>
				<td>
					<b><?php _e('Start Date','mga')?>:</b> <input type="text" size="10" name="sale_dt[start]" value="<?php echo $sale_dt['start']?>"/>
				    <b><?php _e('End Date','mga')?></b><input type="text" size="10" name="sale_dt[end]" value="<?php echo $sale_dt['end']?>"/>					
					<input type="button" value="<?php _e('Display Sales','mga')?>" onclick="filter_sales()" class="button"/>									
				</td>				
			</tr>
			<tr>
				<td><label id="error_all"></label></td>
			</tr>	
			<tr>
				<td align="left">
					<div id="statsoverview">
						<?php f_stats_overview();?>
					</div>					
				</td>
			</tr>
		</table>
		</form>
	</div>
	<script language="javascript">
		<!--
		// onready
		jQuery(document).ready(function(){   							
			// date
			jQuery("#frmstatsoverview :input[name^='sale_dt[']").each(function(i){
						jQuery(this)
						 .attr("size","11")
						 .attr("maxlength","10")						
						 .datepicker({showOn:'focus',buttonImage:'<?php echo MGA_PLUGIN_ASSETS_URL?>/images/icons/calendar.png',buttonImageOnly:true});
			});
			// wrap scope ??? what a solution
			jQuery("#ui-datepicker-div").wrap("<div class='mga'></div>");	
			
			// filter
			filter_sales=function(){				
				// add form validation
				jQuery("#frmstatsoverview").validate({					
					submitHandler: function(form) {					    					
						jQuery("#frmstatsoverview").ajaxSubmit({type: "POST",
												  url: 'admin.php?page=mga/admin&load=dashboard&mode=stats_overview',
												  dataType: 'html',		
												  data:{filter_mode:'date'},										  										 
												  beforeSubmit: function(){	
													jQuery('#wrap-admin-home #message').remove();		
													jQuery('#wrap-admin-home').prepend('<div id="message" class="running"> <?php _e('Loading','mga')?>...</div>');									  	
												  },
												  success: function(data){	
														// remove 										   														
														jQuery('#wrap-admin-home #message').remove();
														jQuery("#statsoverview").html(data);																																			   	
												  }});    		
						return false;											
					},
					rules: {							
						'sale_dt[start]': {required:false,date:true},
						'sale_dt[end]': {required:false,date:true}					
					},
					messages: {									
						'sale_dt[start]': {date:"<?php _e('Please enter valid date','mga')?>"},					
						'sale_dt[end]': {date:"<?php _e('Please enter valid date','mga')?>"}
					},
					errorClass: 'validation-error',
					errorPlacement: function(error, element) {						
						error.appendTo(jQuery("#error_all"));
					}
				});	
				// execute
				jQuery("#frmstatsoverview").submit();
			}
			// upgrade
			create_upgrade=function(v){				
				jQuery('#admin_home .content-div').tabs('remove',1);
				jQuery('#admin_home .content-div').tabs('add','admin.php?page=mga/admin&load=dashboard&mode=upgrade&new_version='+v,'Upgrade',1);
				jQuery('#admin_home .content-div').tabs('select',1);
			}
		});
	//-->	
	</script>		
	<?php
}

// stats
function f_stats_overview(){	
	global $wpdb;
	extract($_POST);
	// default filter
	$filter="AND month(`[date_column]`)=month(CURRENT_DATE)";
	$message_header="for this Month";
	// date filter
	if(isset($sale_dt['start']) && !empty($sale_dt['start'])){
		if(isset($sale_dt['end']) && !empty($sale_dt['end'])){
			$filter=" AND (DATE_FORMAT(`[date_column]`,'%m/%d/%Y')>='{$sale_dt['start']}' AND DATE_FORMAT(`[date_column]`,'%m/%d/%Y')<='{$sale_dt['end']}')";
			$message_header=" between \"{$sale_dt['start']}\" and \"{$sale_dt['end']}\"";
		}else{
			$filter=" AND DATE_FORMAT(`[date_column]`,'%m/%d/%Y')>='{$sale_dt['start']}'";
			$message_header=" from \"{$sale_dt['start']}\" till date";
		}
	}
	
	$total_clicks      = $wpdb->get_var("SELECT COUNT(id) FROM ".TBL_CLICKS." WHERE 1 ".str_replace('[date_column]','hit_dt',$filter));
	$number_sales      = $wpdb->get_var("SELECT COUNT(id) FROM ".TBL_SALES." WHERE 1 ".str_replace('[date_column]','sale_dt',$filter));	
	$sales_amount      = $wpdb->get_var("SELECT SUM(totalprice) FROM `".TBL_SALES."` WHERE 1 ".str_replace('[date_column]','sale_dt',$filter));		
	$sales_commission  = $wpdb->get_var("SELECT SUM(commission_amount) FROM ".TBL_SALES." WHERE item_type='sales' ".str_replace('[date_column]','sale_dt',$filter));
	$signup_commission = $wpdb->get_var("SELECT SUM(commission_amount) FROM ".TBL_SALES." WHERE item_type='signup' ".str_replace('[date_column]','sale_dt',$filter));
	?>
	<div class="updated"><b><?php _e('Affiliate Stats Overview','mga');?> <?php echo $message_header?></b></div>
	<ul>
		<li><?php _e('Total Clicks','mga');?>: <?php echo $total_clicks?></li>
		<li><?php _e('Number of Sales','mga');?>: <?php echo $number_sales?></li>
		<li><?php _e('Total Sales Amount','mga');?>: <?php echo mga_get_setting('currency_symbol').number_format($sales_amount,2,'.','.')?></li>
		<li><?php _e('Total Sales Commission','mga');?>: <?php echo mga_get_setting('currency_symbol').number_format($sales_commission,2,'.','.')?></li>
		<li><?php _e('Total New Affiliate Signup Commission','mga');?>: <?php echo mga_get_setting('currency_symbol').number_format($signup_commission,2,'.','.')?></li>							
	</ul>
	<?php
}
// activate
function f_activate(){
	// save
	if(isset($_POST['process']) && $_POST['process']=='true'){		
		extract($_POST);
		$status = 'error';
		if(!empty($email)){			
			$message=mga_validate_subscription($email);			
			if($message===true){
				$status ='success';
				$message  =__('Your Acount has been activated.','mga');
			}
		}else{			
			$message =__('Email is not provided.','mga');
		}		
		// the response
		echo json_encode(array('status'=>$status,'message'=>$message));
		exit();
	}		
}
// 


// execute

// end of file